package com.example.viewpage;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.os.Parcelable;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.animation.Animation;
import android.view.animation.TranslateAnimation;
import android.widget.ArrayAdapter;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.support.v4.app.NavUtils;
import android.support.v4.view.PagerAdapter;
import android.support.v4.view.ViewPager;
import android.support.v4.view.ViewPager.OnPageChangeListener;

@SuppressLint({ "ParserError", "WrongViewCast", "ResourceAsColor" })
public class MainActivity extends Activity implements  OnClickListener,com.example.viewpage.MySideBar.OnTouchingLetterChangedListener {
    //listViewļ
	private int count=0;
	
	//VIewPaerؼ	
	private ViewPager vp;
	
	//VIewPagerԴ
	private MyPagerAdapter myAdapter; 
	
	//ΪVIewPagerVIewļ
	private List<View> vessel=new ArrayList<View>();
	
	//һ͵2
	private View view1,view2;
	
	//һVIewİť
	private Button layout1_btn_ok;
	
	//2 VIewİť
	private Button layout2_btn_ok;
	
	//İť
	
	private TextView main_btn1,main_btn2;

	// ͼƬ 
	private ImageView cursor;
	
	//2ListVIewؼ
	private ListView list;
	
	//listViewԴ
	  ArrayAdapter<String> arraydp;
	  private int offset = 0;// ͼƬƫ  
	  private int currIndex = 0;// ǰҳ  
	 private int bmpW;// ͼƬ 
      
    //ListViewݼ
    private static List<UserInfo> userInfos;
	//ʾĸ
    private TextView overlay;
	//listViewұߵĵѡ
	private MySideBar myView;
	//ListViewԴ
	private static MyUserInfoAdapter adapter;
	
	private OverlayThread overlayThread = new OverlayThread();
	
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        InitImageView();
        init();     
    
    }
	/**
	 * ʼؼͰ¼
	 */
   public void init()
   {
	
	 view1=this.getLayoutInflater().inflate(R.layout.layout1,null);
	 view2=this.getLayoutInflater().inflate(R.layout.layout2,null);
	 vessel.add(view1);
	 vessel.add(view2);
	 vp=(ViewPager)findViewById(R.id.viewpagerLayout);
	 myAdapter=new MyPagerAdapter();
	 vp.setAdapter(myAdapter);
	 //ʼĬϵֵΪ0
	 vp.setCurrentItem(0); 
	 vp.setOnPageChangeListener(new MyOnPageChangeListener());
	 cursor=(ImageView)findViewById(R.id.cursor);
	 main_btn1=(TextView)findViewById(R.id.main_btn1);
	 main_btn2=(TextView)findViewById(R.id.main_btn2);
	 main_btn1.setOnClickListener(this);
	 main_btn2.setOnClickListener(this);
	 layout1_btn_ok=(Button)view1.findViewById(R.id.layout_btn_ok);
     layout2_btn_ok=(Button)view2.findViewById(R.id.layout2_btn_ok);
     layout1_btn_ok.setOnClickListener(this);
     layout2_btn_ok.setOnClickListener(this);
     list=(ListView)view2.findViewById(R.id.lvShow);
		myView = (MySideBar) view2.findViewById(R.id.myView);
		overlay = (TextView)view2. findViewById(R.id.tvLetter);
		//adapter = new MyUserInfoAdapter(this, userInfos);
		list.setTextFilterEnabled(true);
		overlay.setVisibility(View.INVISIBLE);
        //list.setAdapter(adapter);
        myView.setOnTouchingLetterChangedListener(this);
        myHandler.sendEmptyMessage(1);
   }
    /*
     *ʼ  
     */
 private void InitImageView() {  

	             cursor = (ImageView)findViewById(R.id.cursor);  

	             bmpW = BitmapFactory.decodeResource(getResources(), R.drawable.a)  

	                    .getWidth();// ȡͼƬ  

	             DisplayMetrics dm = new DisplayMetrics();  

	            getWindowManager().getDefaultDisplay().getMetrics(dm);  

	            int screenW = dm.widthPixels;// ȡֱʿ  
	              System.out.println("bmpw:"+bmpW+"screenW:"+screenW);
	             offset = (screenW/3-bmpW)/2;// ƫ  
	              Matrix matrix = new Matrix();  
	             matrix.postTranslate(offset, 0);  
                 System.out.println("offset:"+offset);
	             cursor.setImageMatrix(matrix);// öʼλ  

	        } 

   @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.activity_main, menu);
        return true;
    }
    //
   class MyPagerAdapter extends PagerAdapter
   {

	

	         public void destroyItem(View arg0, int arg1, Object arg2) {  

	              Log.d("k", "destroyItem");  

	               ((ViewPager) arg0).removeView(vessel.get(arg1));  

	            }  

	     
	            public void finishUpdate(View arg0) {  

	               Log.d("k", "finishUpdate");  

	         }  
	         public int getCount() {  

	            Log.d("k", "getCount");  

	               return vessel.size();  

	         }  
	       public Object instantiateItem(View arg0, int arg1) {  

	              Log.d("k", "instantiateItem");  

	               ((ViewPager) arg0).addView(vessel.get(arg1),0);  

	               return vessel.get(arg1);  

	           }  

	            public boolean isViewFromObject(View arg0, Object arg1) {  

	                Log.d("k", "isViewFromObject");  

	                return arg0==(arg1);  

	           }  

	          public void restoreState(Parcelable arg0, ClassLoader arg1) {  

	                Log.d("k", "restoreState");  

	           }  

	           public Parcelable saveState() {  

	               Log.d("k", "saveState");  
	               return null;  
	           }  
	          @Override 

	           public void startUpdate(View arg0) {  

	              Log.d("k", "startUpdate");  

	          }  

   }

   
   /**
	 * ҳл
	 */
	public class MyOnPageChangeListener implements OnPageChangeListener {
        
		int one = offset *2 + bmpW;// ҳ1 -> ҳ2 ƫ
	   //int two = one * 2;// ҳ1 -> ҳ3 ƫ
		@Override
		public void onPageSelected(int arg0) {
			System.out.println(arg0+"currenIndex:"+currIndex);
			Animation animation = null;		
			switch (arg0) {
			case 0:
				if (currIndex == 1) {
					animation = new TranslateAnimation(one, 0, 0, 0);
				}/* else if (currIndex == 2) {
					animation = new TranslateAnimation(two, 0, 0, 0);
				}*/
				break;
			case 1:
				if (currIndex == 0) {
					animation = new TranslateAnimation(offset, one, 0, 0);
				
				} /*else if (currIndex == 2) {
					animation = new TranslateAnimation(two, one, 0, 0);
				}*/
				break;
		/*	case 2:
				if (currIndex == 0) {
					animation = new TranslateAnimation(offset, two, 0, 0);
				} else if (currIndex == 1) {
					animation = new TranslateAnimation(one, two, 0, 0);
				}
				break;*/
			}
			
			currIndex = arg0;
			animation.setFillAfter(true);// True:ͼƬͣڶλ
			animation.setDuration(300);
			cursor.startAnimation(animation);
		}

		@Override
		public void onPageScrolled(int arg0, float arg1, int arg2) {
		}

		@Override
		public void onPageScrollStateChanged(int arg0) {
		}
	}
	/**|
	 * ¼
	 */
    @SuppressLint({ "ResourceAsColor", "ResourceAsColor" })
	public void onClick(View v) {
 	// TODO Auto-generated method stub
	switch(v.getId())
	{
	case R.id.layout2_btn_ok:	 
	   Toast.makeText(this, "2ҳBUtton",50).show();	 	
	   break;
	case R.id.layout_btn_ok:
		  Toast.makeText(this, "1ҳBUtton",50).show();	 
	     //EditText tv=(EditText)view1.findViewById(R.id.layout_txt_tv1);
		// tv.setText(""+count+"");
		 count++;
		break;
		
	case R.id.main_btn1:
		main_btn1.setBackgroundColor(R.color.skyblue);
		//main_btn1.setTextColor(R.color.red);
		main_btn2.setBackgroundColor(R.color.red);
		vp.setCurrentItem(0);
		break;
	case R.id.main_btn2:
		main_btn2.setBackgroundColor(R.color.skyblue);
		main_btn1.setBackgroundColor(R.color.red);
		vp.setCurrentItem(1);	
		break;
	
	}
	
} 
    /**
     * ʼlistVIewҪ ƥ
     */
	private void getUserInfos() {

		UserInfo[] userinfoArray = new UserInfo[] {
				new UserInfo("ɮ", "18765432345", PinyinUtils.getAlpha("ɮ")),
				new UserInfo("ʦ", "18765432345", PinyinUtils.getAlpha("ʦ")),
				new UserInfo("", "18765432345", PinyinUtils.getAlpha("")),
				new UserInfo("8899", "18765432345",
						PinyinUtils.getAlpha("8899")),
				new UserInfo("", "18765432345", PinyinUtils.getAlpha("")),
				new UserInfo("", "18765432345", PinyinUtils.getAlpha("")),
				new UserInfo("", "18765432345", PinyinUtils.getAlpha("")),
				new UserInfo("ŶB", "18876569008", PinyinUtils.getAlpha("ŶB")),
				new UserInfo("", "18765432345", PinyinUtils.getAlpha("")),
				new UserInfo("", "18765432345", PinyinUtils.getAlpha("")),
				new UserInfo("ŶB", "18876569008", PinyinUtils.getAlpha("ŶB")),
				new UserInfo("", "18765432345", PinyinUtils.getAlpha("")),
				new UserInfo("", "18765432345", PinyinUtils.getAlpha("")),
				new UserInfo("ŶB", "18876569008", PinyinUtils.getAlpha("ŶB")),
				new UserInfo("", "18765432345", PinyinUtils.getAlpha("")),
				new UserInfo("", "18765432345", PinyinUtils.getAlpha("")),
				new UserInfo("ŶB", "18876569008", PinyinUtils.getAlpha("ŶB")),
				new UserInfo("", "18909876545", PinyinUtils.getAlpha("")),
				new UserInfo("С", "18909876545", PinyinUtils.getAlpha("С")),
				new UserInfo("", "18909876545", PinyinUtils.getAlpha("")),
				new UserInfo("", "18909876545", PinyinUtils.getAlpha("")),
				new UserInfo("޼", "18909876545", PinyinUtils.getAlpha("޼")),
				new UserInfo("С", "18909876545", PinyinUtils.getAlpha("С")) };

		Arrays.sort(userinfoArray, new PinyinComparator());

		userInfos = Arrays.asList(userinfoArray);

	}
	/**
	 * Viewĵ¼
	 */
	@Override
	public void onTouchingLetterChanged(String s) {
		// TODO Auto-generated method stub
		overlay.setText(s);
		overlay.setVisibility(View.VISIBLE);
		handler.removeCallbacks(overlayThread);
		handler.postDelayed(overlayThread, 1000);
		if (alphaIndexer(s) > 0) {
			int position = alphaIndexer(s);
			Log.i("coder", "position:" + position);
			list.setSelection(position);

		}
	}

	public int alphaIndexer(String s) {
		int position = 0;
		for (int i = 0; i < userInfos.size(); i++) {

			if (userInfos.get(i).getPy().startsWith(s)) {
				position = i;
				break;
			}
		}
		Log.i("coder", "i" + position + userInfos.get(position));
		return position;
	}
	private Handler handler = new Handler() {
	};
     
	private class OverlayThread implements Runnable {

		public void run() {
			overlay.setVisibility(View.GONE);
		}

	}
    
	
	private Handler myHandler=new Handler(){

		@Override
		public void handleMessage(Message msg) {
			getUserInfos();
			adapter = new MyUserInfoAdapter(MainActivity.this, userInfos);		
	        list.setAdapter(adapter);
			// TODO Auto-generated method stub
			super.handleMessage(msg);
		}
		
		
	};
}
